#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <assert.h>

#include <linux/mempool.h>
#include <linux/slab.h>

int nr_allocated;

void *mempool_alloc(mempool_t *pool, int gfp_mask)
{
	return pool->alloc(gfp_mask, pool->data);
}

void mempool_free(void *element, mempool_t *pool)
{
	pool->free(element, pool->data);
}

mempool_t *mempool_create(int min_nr, mempool_alloc_t *alloc_fn,
			mempool_free_t *free_fn, void *pool_data)
{
	mempool_t *ret = malloc(sizeof(*ret));

	ret->alloc = alloc_fn;
	ret->free = free_fn;
	ret->data = pool_data;
	return ret;
}

#include <pthread.h>
static pthread_mutex_t stat_mutex = PTHREAD_MUTEX_INITIALIZER;
void *kmem_cache_alloc(kmem_cache_t *cachep, int flags)
{
	void *ret = malloc(cachep->size);
	memset(ret, 0, cachep->size);
	nr_allocated++;
	return ret;
}

void kmem_cache_free(kmem_cache_t *cachep, void *objp)
{
	assert(objp);
	nr_allocated--;
	memset(objp, 0, cachep->size);
	free(objp);
}

kmem_cache_t *
kmem_cache_create(const char *name, size_t size, size_t offset,
        unsigned long flags, void (*ctor)(void*, kmem_cache_t*, unsigned long),
        void (*dtor)(void*, kmem_cache_t *, unsigned long))
{
	kmem_cache_t *ret = malloc(sizeof(*ret));

	ret->size = size;
	return ret;
}
