#ifndef __RCUPDATE_H__
#define __RCUPDATE_H__

#include <linux/list.h>

#define smp_wmb()       __asm__ __volatile__ ("eieio" : : : "memory")
#define smp_mb()       __asm__ __volatile__ ("sync" : : : "memory")

void rcu_init(void);
void rcu_exit(void);

#if defined(_REENTRANT) || defined(_THREAD_SAFE)
void rcu_read_lock(void);
void rcu_read_unlock(void);

struct rcu_head {
	int rcu_gen;
	struct list_head list;
	void (*func)(struct rcu_head *head);
};

void call_rcu(struct rcu_head *x, void (*func)(struct rcu_head *head));
# define rcu_assign_pointer(p, v)	\
do {					\
	smp_wmb();			\
	(p) = (v);			\
} while (0)

#else
#define rcu_read_lock()
#define rcu_read_unlock()

struct rcu_head {
};

# define call_rcu(x, fn) (fn(x))
# define rcu_assign_pointer(p, v)	((p) = (v))

#endif

#define rcu_dereference(p) (p)

#endif
