#ifndef SLAB_H
#define SLAB_H

#define GFP_KERNEL 1
#define SLAB_HWCACHE_ALIGN 1
#define SLAB_PANIC 2

typedef struct {
	int size;
} kmem_cache_t;

void *kmem_cache_alloc(kmem_cache_t *cachep, int flags);
void kmem_cache_free(kmem_cache_t *cachep, void *objp);

kmem_cache_t *
kmem_cache_create(const char *name, size_t size, size_t offset,
        unsigned long flags, void (*ctor)(void*, kmem_cache_t*, unsigned long),
        void (*dtor)(void*, kmem_cache_t *, unsigned long));

#endif		/* SLAB_H */
